/*
 * Copyright (C) 2018 Inteno Broadband Technology AB. All rights reserved.
 *
 * Authors: Hrvoje Varga    <hrvoje.varga@sartura.hr>
 *          Matija Amidzic  <matija.amidzic@sartura.hr>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 */
#ifndef __MONITOR_H__

#include <libubox/list.h>

typedef enum { STREAM_UNSUPPORTED, STREAM_STDOUT, STREAM_STDERR } monitor_stream_e;
typedef enum { PATTERN_UNSUPPORTED, PATTERN_MATCH, PATTERN_NOT_MATCH, PATTERN_REGEX } monitor_match_pattern_e;

typedef struct monitor_s {
    char *app;
    char *test;
    monitor_stream_e stream;
    monitor_match_pattern_e pattern_type;
    char *match_pattern;
    char *execute;
    int interval;
    int nr_tests;

    struct list_head head;
} monitor_t;

int monitor_start(char *ubus_socket_path, struct list_head *monitors);
void monitor_stop(void);

extern void (*monitor_test_cb)(char *command);
extern void (*monitor_execute_cb)(char *command);

#define __MONITOR_H__
#endif /* __MONITOR_H */
